/***********************************************************************/
/*                                                                     */
/*  FILE        :RC_servo1.c                                           */
/*  DATE        :Mon, Oct 02, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8/3694F                                              */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.5).     */
/*                                                                     */
/***********************************************************************/
/*
;	RC_servo1.c		2006-10-29
;
;	H8/3694-USB demo2
;
;	CPU:	H8/3694F (20MHz)
;
;				c[H[
;					M.Ohta
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
*/



#include <machine.h>
#include "iodefine.h"

#ifdef __cplusplus
extern "C" {
void abort(void);
#endif
void main(void);
#ifdef __cplusplus
}
#endif



volatile unsigned char HEX_H;
volatile unsigned char HEX_L;
volatile unsigned int CH_NO;
volatile unsigned int RC_posi[24];

volatile unsigned int RX_POINTER;
volatile unsigned char CR_FLAG;
volatile unsigned char I2CBUF[32];
volatile unsigned char RXBUF[64];




void TX1RS(unsigned char TX_data);




void Timer(int Time){						//Time(mSec)

int i,j;

	for(j=0; j<Time; j++){
		for(i=0; i<3500; i++){
		}
	}
}



unsigned char HEX_BIN(unsigned char hex){
	if(hex > 0x39){return ((hex & 0x0f)+9);}
	else{return (hex & 0x0f);}
}



unsigned char HEX2_BIN(unsigned char *p){

unsigned char hi,lo;

	hi = HEX_BIN(*p);
	p +=1;
	lo = HEX_BIN(*p);
	return hi*16 + lo;

}




unsigned int HEX4_BIN(unsigned char *p){

unsigned char hh,hl,lh,ll;

	hh = HEX_BIN(*p);
	p +=1;
	hl = HEX_BIN(*p);
	p +=1;
	lh = HEX_BIN(*p);
	p +=1;
	ll = HEX_BIN(*p);
	p +=1;

	return hh*4096 + hl*256 + lh*16 + ll;

}



unsigned char HEX2_BCD(unsigned char *p){

unsigned char hi,lo;

	hi = *p & 0x0f;
	p += 1;
	lo = *p & 0x0f;

	return hi*16 + lo;
	
} 




void BIN_HEX(unsigned char bin){			//binHEX_H,HEX_L

unsigned char dummy;

	dummy = (bin/16) & 0x0f;
	if(dummy > 9){HEX_H = dummy + 0x37;}
	else{HEX_H = dummy | 0x30;}

	dummy = bin & 0x0f;
	if(dummy > 9){HEX_L = dummy + 0x37;}
	else{HEX_L = dummy | 0x30;}
	
}
	
	 

void TX1HEX(unsigned char bin){

	BIN_HEX(bin);
	TX1RS(HEX_H);
	TX1RS(HEX_L);
}



void TX2HEX(unsigned int word){

unsigned char dummy;

	dummy = word/256;
	BIN_HEX(dummy);
	TX1RS(HEX_H);
	TX1RS(HEX_L);

	dummy = word & 0xff;
	BIN_HEX(dummy);
	TX1RS(HEX_H);
	TX1RS(HEX_L);
}









void AD_START(void){						//A/D trig.

	AD.ADCSR.BIT.ADST = 1;
	while(AD.ADCSR.BIT.ADF == 0){
	}
	AD.ADCSR.BIT.ADST = 0;
	AD.ADCSR.BIT.ADF = 0;
}



void TX1RS(unsigned char TX_data){			//TX 1data to PC

	while(SCI3.SSR.BIT.TDRE == 0){}
	SCI3.TDR = TX_data;
}




void INITIALIZE(void){

	unsigned char dummy;

	Timer(10);
	
											//(I2C)
	IIC2.ICCR1.BYTE = 0x82;					//CLK=417KHz
	IIC2.ICCR2.BYTE = 0x00;	
	IIC2.ICMR.BYTE = 0x40;					//MSB first, Wait, 9bit
	IIC2.SAR.BYTE =	0x00;
	IIC2.ICCR2.BIT.IICRST = 1;				//IICRST=1(I2C Reset)
	Timer(1);
	IIC2.ICCR2.BIT.IICRST = 0;				//IICRST=0
	
											//(I/O PORT)
	IO.PCR1 = 0x07;							//P10-P13 output
	IO.PCR7 = 0x20;							//P75 output

											//(A/D Converter)
	AD.ADCR.BYTE = 0;						//AD trig.non
	AD.ADCSR.BYTE = 0x13;					//Scan mode 0~3
	AD_START();								//dummy

											//(TimerA)
	TA.TMA.BYTE = 0x89;						//TMOV=W/32, W, 0.5S
	IENR1.BIT.IENTA = 1;					//TimerA IRQ enable
	IRR1.BIT.IRRTA = 0;

											//(Timer W = PWM)
	TW.TMRW.BYTE = 0x07;					//TimerW stop, PWMD, PWMC, PWMB
	TW.TCRW.BYTE = 0x90;					//ClearW at IMFA, CLK=/2(10MHz)
	TW.TIERW.BYTE = 0x01;					//IRQ enable by IMFA
//	TW.TIOR0.BYTE = 0x20;					//GRB 
//	TW.TIOR0.BYTE = 0x22;					//GRD ,GRC 
	TW.GRA = 25000;							//PWM Period = 2.5mS
	TW.GRB = 10000;							//PWM Width = 1.5mS(25000-10000)*0.1uS
	TW.GRC = 10000;
	TW.GRD = 10000;
	TW.TCNT = 0;							//clear TimerW
	TW.TSRW.BYTE = 0;						//cear Flag
	TW.TMRW.BIT.CTS = 1;					//TimerW start
	

											//(SCI3)
	SCI3.SMR.BYTE = 0;
	SCI3.SCR3.BYTE = 0;						//8-N-1
	SCI3.BRR = 15;							//38400bps
	Timer(1);
	dummy = SCI3.RDR;
	SCI3.SCR3.BYTE = 0x70;					//RX IRQ enable
	SCI3.SSR.BYTE = 0x80;
	IO.PMR1.BIT.TXD = 1;					//P22=TXD
	Timer(1);
	dummy = SCI3.SSR.BYTE;
	dummy = SCI3.RDR;

}



void RC_demo(void){								//DEMO motion

int i,j;


		for(i=0; i<75; i++){
			Timer(40);
			RC_posi[0] +=100;
			RC_posi[2] +=100;
			RC_posi[4] +=100;
			RC_posi[6] +=100;
		}
		for(i=0; i<75; i++){
			Timer(40);
			RC_posi[1] -=100;
			RC_posi[3] -=100;
			RC_posi[5] -=100;
			RC_posi[7] -=100;
		}		

	for(i=0; i<150; i++){
		Timer(20);
		RC_posi[0] -=100;
		RC_posi[1] +=100;
		RC_posi[2] -=100;
		RC_posi[3] +=100;
		RC_posi[4] -=100;
		RC_posi[5] +=100;
		RC_posi[6] -=100;
		RC_posi[7] +=100;	
	}
	Timer(500);
		RC_posi[0] = 20000;
		RC_posi[1] = 10000;
		RC_posi[2] = 20000;
		RC_posi[3] = 10000;
		RC_posi[4] = 20000;
		RC_posi[5] = 10000;
		RC_posi[6] = 20000;
		RC_posi[7] = 10000;
	Timer(1000);
		RC_posi[0] = 15000;
		RC_posi[1] = 15000;
		RC_posi[2] = 15000;
		RC_posi[3] = 15000;
		RC_posi[4] = 15000;
		RC_posi[5] = 15000;
		RC_posi[6] = 15000;
		RC_posi[7] = 15000;
}



void main(void){

unsigned int i,dummy;

	for(i=0; i<24; i++){RC_posi[i] = 15000;}	//Initial RC position

	CH_NO = 0;
	set_imask_ccr(1);							//IRQ disable
	INITIALIZE();
	set_imask_ccr(0);							//IRQ enable




/*	ȌARC_posi[0],RC_posi[1],RC_posi[2] ɒlނƂ
@@PWMB,PWMC,PWMD ̃pX𐧌ł܂B                    */
/*	RC_posi = 10000 ŃpX@1mS łB			   */

/*@܂ASCI3 ̃R}hŐ䂷Ƃ\łB@@@@@  */
/*  R}h̓oCi4oCg(0xFF,CHNo,RC_posi(Hi),RC_posi(Lo)) */



	RC_demo();									//DEMO play


Loop:
	Timer(10);
		
	AD_START();									//Read KEY
	for(i=0; i<8; i++){
		AD.ADCSR.BIT.CH = 0;					//AN0
		dummy = AD.ADDRA / 64;					//El(10bit)
		if(dummy > (64+(7-i)*128)){				//+KEY ?
			RC_posi[i] += 100;
			if(RC_posi[i] > 24000){RC_posi[i] = 24000;}
			goto Loop;
			break;
		}

		AD.ADCSR.BIT.CH = 1;					//AN1
		dummy = AD.ADDRB / 64;					//El(10bit)
		if(dummy > (64+(7-i)*128)){				//-KEY ?
			RC_posi[i] -= 100;
			if(RC_posi[i] < 6000){RC_posi[i] = 6000;}
			goto Loop;
			break;
		}
	}
	goto Loop;
}






#ifdef __cplusplus
void abort(void)
{
	
}
#endif
                 
