/***********************************************************************/
/*                                                                     */
/*  FILE        :intprg.c                                              */
/*  DATE        :Mon, Oct 02, 2006                                     */
/*  DESCRIPTION :Interrupt Program                                     */
/*  CPU TYPE    :H8/3694F                                              */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.5).     */
/*                                                                     */
/***********************************************************************/
                  



#include "iodefine.h"
#include <machine.h>
#pragma section IntPRG

extern unsigned int CH_NO;
extern unsigned int RC_posi[24];
extern unsigned char RX_POINTER;
extern unsigned char CR_FLAG;
extern unsigned char RXBUF[64];


// vector 1 Reserved

// vector 2 Reserved

// vector 3 Reserved

// vector 4 Reserved

// vector 5 Reserved

// vector 6 Reserved

// vector 7 NMI
__interrupt(vect=7) void INT_NMI(void) {/* sleep(); */}
// vector 8 TRAP #0
__interrupt(vect=8) void INT_TRAP0(void) {/* sleep(); */}
// vector 9 TRAP #1
__interrupt(vect=9) void INT_TRAP1(void) {/* sleep(); */}
// vector 10 TRAP #2
__interrupt(vect=10) void INT_TRAP2(void) {/* sleep(); */}
// vector 11 TRAP #3
__interrupt(vect=11) void INT_TRAP3(void) {/* sleep(); */}
// vector 12 Address break
__interrupt(vect=12) void INT_ABRK(void) {/* sleep(); */}
// vector 13 SLEEP
__interrupt(vect=13) void INT_SLEEP(void) {/* sleep(); */}
// vector 14 IRQ0
__interrupt(vect=14) void INT_IRQ0(void) {/* sleep(); */}
// vector 15 IRQ1
__interrupt(vect=15) void INT_IRQ1(void) {/* sleep(); */}
// vector 16 IRQ2
__interrupt(vect=16) void INT_IRQ2(void) {/* sleep(); */}
// vector 17 IRQ3
__interrupt(vect=17) void INT_IRQ3(void) {/* sleep(); */}
// vector 18 WKP
__interrupt(vect=18) void INT_WKP(void) {/* sleep(); */}


// vector 19 Timer A Overflow
__interrupt(vect=19) void INT_TimerA(void) {

	IRR1.BIT.IRRTA = 0;							//clear FLAG
	
	if(IO.PDR7.BIT.B5 == 0){
		IO.PDR7.BIT.B5 = 1;						//P75 ]
	}
	else{
		IO.PDR7.BIT.B5 = 0;
	}
}


// vector 20 Reserved



// vector 21 Timer W
__interrupt(vect=21) void INT_TimerW(void) {

		TW.TSRW.BIT.IMFA &= 0;					//clear FLAG
		IO.PDR1.BYTE = CH_NO & 0xff;
		TW.GRB = 25000 - RC_posi[CH_NO];
		TW.GRC = 25000 - RC_posi[8+CH_NO];
		TW.GRD = 25000 - RC_posi[16+CH_NO];
		CH_NO += 1;								//Next CH.
		if(CH_NO > 7){CH_NO = 0;}
}




// vector 22 Timer V
__interrupt(vect=22) void INT_TimerV(void) {/* sleep(); */}



// vector 23 SCI3
__interrupt(vect=23) void INT_SCI3(void) {

unsigned char dummy;
unsigned int ch;

	dummy = SCI3.RDR;
	if(dummy == 0xff){RX_POINTER = 0;}
	RXBUF[RX_POINTER] = dummy;
	if(RX_POINTER < 64){RX_POINTER++;}
	dummy = SCI3.SSR.BYTE;
	SCI3.SSR.BYTE = dummy & 0x87;
	if(RX_POINTER == 4){
		ch = RXBUF[1] & 0xff;
		RC_posi[ch] = (RXBUF[2] & 0xff)*256 + (RXBUF[3] & 0xff);
	}
}



// vector 24 IIC2
__interrupt(vect=24) void INT_IIC2(void) {/* sleep(); */}
// vector 25 ADI
__interrupt(vect=25) void INT_ADI(void) {/* sleep(); */}
